JUCE: FileOutputStream Class Reference

JUCE

Public Member Functions | List of all members
FileOutputStream Class Reference
juce_core » files

An output stream that writes into a local file. More...

`#include <juce_FileOutputStream.h>`

Inheritance diagram for FileOutputStream:

## Public Member Functions
| FileOutputStream (const File &fileToWriteTo, size_t bufferSizeToUse=16384)
| Creates a FileOutputStream. More...
| ~FileOutputStream () override
| Destructor. More...
const File & | getFile () const
| Returns the file that this stream is writing to. More...
const Result & | getStatus () const noexcept
| Returns the status of the file stream. More...
bool | failedToOpen () const noexcept
| Returns true if the stream couldn't be opened for some reason. More...
bool | openedOk () const noexcept
| Returns true if the stream opened without problems. More...
Result | truncate ()
| Attempts to truncate the file to the current write position. More...
void | flush () override
| If the stream is using a buffer, this will ensure it gets written out to the destination. More...
int64 | getPosition () override
| Returns the stream's current position. More...
bool | setPosition (int64) override
| Tries to move the stream's output position. More...
bool | write (const void *, size_t) override
| Writes a block of data to the stream. More...
bool | writeRepeatedByte (uint8 byte, size_t numTimesToRepeat) override
| Writes a byte to the output stream a given number of times. More...
Public Member Functions inherited from OutputStream
virtual | ~OutputStream ()
| Destructor. More...
virtual bool | writeByte (char byte)
| Writes a single byte to the stream. More...
virtual bool | writeBool (bool boolValue)
| Writes a boolean to the stream as a single byte. More...
virtual bool | writeShort (short value)
| Writes a 16-bit integer to the stream in a little-endian byte order. More...
virtual bool | writeShortBigEndian (short value)
| Writes a 16-bit integer to the stream in a big-endian byte order. More...
virtual bool | writeInt (int value)
| Writes a 32-bit integer to the stream in a little-endian byte order. More...
virtual bool | writeIntBigEndian (int value)
| Writes a 32-bit integer to the stream in a big-endian byte order. More...
virtual bool | writeInt64 (int64 value)
| Writes a 64-bit integer to the stream in a little-endian byte order. More...
virtual bool | writeInt64BigEndian (int64 value)
| Writes a 64-bit integer to the stream in a big-endian byte order. More...
virtual bool | writeFloat (float value)
| Writes a 32-bit floating point value to the stream in a binary format. More...
virtual bool | writeFloatBigEndian (float value)
| Writes a 32-bit floating point value to the stream in a binary format. More...
virtual bool | writeDouble (double value)
| Writes a 64-bit floating point value to the stream in a binary format. More...
virtual bool | writeDoubleBigEndian (double value)
| Writes a 64-bit floating point value to the stream in a binary format. More...
virtual bool | writeCompressedInt (int value)
| Writes a condensed binary encoding of a 32-bit integer. More...
virtual bool | writeString (const String &text)
| Stores a string in the stream in a binary format. More...
virtual bool | writeText (const String &text, bool asUTF16, bool writeUTF16ByteOrderMark, const char *lineEndings)
| Writes a string of text to the stream. More...
virtual int64 | writeFromInputStream (InputStream &source, int64 maxNumBytesToWrite)
| Reads data from an input stream and writes it to this stream. More...
void | setNewLineString (const String &newLineString)
| Sets the string to write to the stream when a new line is written. More...
const String & | getNewLineString () const noexcept
| Returns the current new-line string that was set by setNewLineString(). More...

## Additional Inherited Members
Protected Member Functions inherited from OutputStream
| OutputStream ()

## Detailed Description

An output stream that writes into a local file.

See also
  OutputStream, FileInputStream, File::createOutputStream

## Constructor & Destructor Documentation

## ◆ FileOutputStream()

FileOutputStream::FileOutputStream | ( | const File & | fileToWriteTo,
|  | size_t | bufferSizeToUse = `16384`
| ) |  |

Creates a FileOutputStream.

If the file doesn't exist, it will first be created. If the file can't be created or opened (for example, because the parent directory of the file does not exist), the failedToOpen() method will return true.

If the file already exists when opened, the stream's write-position will be set to the end of the file. To overwrite an existing file, you can truncate it like this:

FileOutputStream stream (file);
if (stream.openedOk())
{
stream.setPosition (0);
stream.truncate();
...
}
FileOutputStream
An output stream that writes into a local file.
Definition: juce_FileOutputStream.h:36
gl::stream
GLuint GLuint stream
Definition: juce_gl.h:2399

Destroying a FileOutputStream object does not force the operating system to write the buffered data to disk immediately. If this is required you should call flush() before triggering the destructor.

See also
  TemporaryFile

## ◆ ~FileOutputStream()

FileOutputStream::~FileOutputStream | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ getFile()

const File & FileOutputStream::getFile | ( |  | ) | const

Returns the file that this stream is writing to.

## ◆ getStatus()

const Result & FileOutputStream::getStatus | ( |  | ) | const
| noexcept

Returns the status of the file stream.

The result will be ok if the file opened successfully. If an error occurs while opening or writing to the file, this will contain an error message.

## ◆ failedToOpen()

bool FileOutputStream::failedToOpen | ( |  | ) | const
| noexcept

Returns true if the stream couldn't be opened for some reason.

See also
  getResult()

## ◆ openedOk()

bool FileOutputStream::openedOk | ( |  | ) | const
| noexcept

Returns true if the stream opened without problems.

See also
  getResult()

## ◆ truncate()

Result FileOutputStream::truncate | ( |  | ) |

Attempts to truncate the file to the current write position.

To truncate a file to a specific size, first use setPosition() to seek to the appropriate location, and then call this method.

## ◆ flush()

void FileOutputStream::flush | ( |  | ) |
| overridevirtual

If the stream is using a buffer, this will ensure it gets written out to the destination.

Implements OutputStream.

## ◆ getPosition()

int64 FileOutputStream::getPosition | ( |  | ) |
| overridevirtual

Returns the stream's current position.

See also
  setPosition

Implements OutputStream.

## ◆ setPosition()

bool FileOutputStream::setPosition | ( | int64 | newPosition | ) |
| overridevirtual

Tries to move the stream's output position.

Not all streams will be able to seek to a new position - this will return false if it fails to work.

See also
  getPosition

Implements OutputStream.

## ◆ write()

bool FileOutputStream::write | ( | const void * | dataToWrite,
|  | size_t | numberOfBytes
| ) |  |
| overridevirtual

Writes a block of data to the stream.

When creating a subclass of OutputStream, this is the only write method that needs to be overloaded - the base class has methods for writing other types of data which use this to do the work.

Parameters

  dataToWrite | the target buffer to receive the data. This must not be null.
  numberOfBytes | the number of bytes to write.

Returns
  false if the write operation fails for some reason

Implements OutputStream.

## ◆ writeRepeatedByte()

bool FileOutputStream::writeRepeatedByte | ( | uint8 | byte,
|  | size_t | numTimesToRepeat
| ) |  |
| overridevirtual

Writes a byte to the output stream a given number of times.

Returns
  false if the write operation fails for some reason

Reimplemented from OutputStream.

The documentation for this class was generated from the following file:

- juce_FileOutputStream.h